# VkCV Demos
A list of demo projects to show of examples for different implementations using the VkCV framework

## Repository
Git LFS is used for bigger resource files like textures and screenshots. So you need to install Git
LFS and use `git lfs install` once. More information about Git LFS
[here](https://git-lfs.github.com/).

## Build
To download all the submodules either clone using `git clone --recurse-submodules` or after
`git clone` use `git submodule update --init --recursive`.

## Demos
Here is the list of demo projects from this repository:

 - [CubeMapping](demos/CubeMapping/README.md)
 - [InstancingDemo](demos/InstancingDemo/README.md)
 - [NormalMapping](demos/NormalMapping/README.md)
 - [SSAO](demos/SSAO/README.md)

## Framework
All the demo projects utilize the 
[VkCV framework](https://gitlab.uni-koblenz.de/vulkan2021/vkcv-framework) which is developed
separate. It is used as submodule via git and it also contains a lot submodules for its modules and
dependencies. So you should either clone this repository with `git clone --recurse-submodules` or 
make sure to clone them in a later step manually.

## Notes
Be aware that those demo projects are built against the version of the VkCV framework which is
used as submodule via git in this repository. So to be compatible with future versions of the
framework some changes/adjustments might be required.
