#version 450

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

layout(set=0, binding=0) uniform matrixBuffer {
    mat4 viewMatrix;
    mat4 projectionMatrix;
};

layout( push_constant ) uniform constants {
    mat4 modelMatrix;
};

layout(location = 0) out vec3 passPosition;
layout(location = 1) out vec3 passNormal;
layout(location = 2) out vec2 passUVCoord;

layout(location = 3) out vec3 passReflectionNormal;
 
void main() {
    passPosition = (viewMatrix * modelMatrix * vec4(position, 1)).xyz;
    passNormal = vec3(transpose(inverse(viewMatrix * modelMatrix)) * vec4(normal, 0));
    passUVCoord = uv;
	
    passReflectionNormal = vec3(viewMatrix * modelMatrix * vec4(normal, 0));
	
    gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);
}
