#version 450

layout(location = 0) in vec3 position;

layout(set=0, binding=0) uniform matrixBuffer {
	mat4 viewMatrix;
	mat4 projectionMatrix;
};

layout(location = 0) out vec3 passTexCoord;
 
void main() {
	passTexCoord = position;

	mat4 vM = mat4(mat3(viewMatrix));

	// Set Pos to xyww instead of xyzw, so that z will always be 1 (furthest from camera)
    gl_Position = (projectionMatrix * vM * vec4(position, 1)).xyww;
}
