#version 450

//incoming data for the single textures
layout(location = 0) in vec4 passPosition;
layout(location = 1) in vec3 passNormal;
layout(location = 2) in vec2 passUVCoord;

struct Material {
	vec3 diffuse;
	float alpha;
};

layout(set=0, binding=1) uniform materialBuffer {
	Material mat;
};

layout(set=0, binding=2) uniform texturePropsBuffer {
	int useColorTexture;
};

layout(set=0, binding=3) uniform texture2D colorTexture;
layout(set=0, binding=4) uniform sampler colorSampler;

//writable textures for deferred screen space calculations
layout(location = 0) out vec4 positionOutput;
layout(location = 1) out vec4 normalOutput;
layout(location = 2) out vec4 colorOutput;
 
void main() {
    positionOutput = passPosition;
    normalOutput = vec4(normalize(passNormal), 1);
	colorOutput = vec4(mat.diffuse, mat.alpha);

	if (useColorTexture != 0) {
		colorOutput = texture(sampler2D(colorTexture, colorSampler), passUVCoord);
	}
}
