#version 450

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

layout(set=0, binding=0) uniform matrixBuffer {
    mat4 viewMatrix;
    mat4 projectionMatrix;
};

layout( push_constant ) uniform constants {
    mat4 modelMatrix;
};

layout(location = 0) out vec4 passPosition;
layout(location = 1) out vec3 passNormal;
layout(location = 2) out vec2 passUVCoord;

void main() {
    passUVCoord = vec2(uv.x, 1.0f - uv.y);

    passPosition = viewMatrix * modelMatrix * vec4(position, 1);
    gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);

    passNormal = vec3(transpose(inverse(viewMatrix * modelMatrix)) * vec4(normal, 0));
}
