#version 450

layout(location = 0) in vec2 passUVCoord;

layout(set=0, binding=0) uniform texture2D colorTexture;
layout(set=0, binding=1) uniform sampler colorSampler;

layout( push_constant ) uniform constants {
	float yAxis;
};

layout(location = 0) out vec4 fragmentColor;

void main() {
	vec4 weights = vec4(2.0, 3.0, 2.0, 1.0);
    
	vec4 sum = vec4(0.0, 0.0, 0.0, 0.0);
	vec2 diff = vec2(1.0, 0.0);

	if (yAxis > 0.5) {
		diff = vec2(0.0, 1.0);
	}

	diff *= (1.0 / 800.0);
	
	for(int i=0; i<4; i++)
	{
		sum += weights[i] * texture(sampler2D(colorTexture, colorSampler), passUVCoord + i*diff);
		sum += weights[i] * texture(sampler2D(colorTexture, colorSampler), passUVCoord - i*diff);
	}
	
	fragmentColor = sum / 16.0;
}