#version 450

layout(location = 0) in vec2 passUVCoord;

layout(set=0, binding=0) uniform texture2D lightTexture;
layout(set=0, binding=1) uniform texture2D colorTexture;
layout(set=0, binding=2) uniform texture2D ssaoTexture;
layout(set=0, binding=3) uniform sampler texSampler;

layout( push_constant ) uniform constants {
	float useLight;
	float useSSAO;
};

layout(location = 0) out vec4 fragmentColor;

void main() {
    vec4 light = texture(sampler2D(lightTexture, texSampler), passUVCoord);
    vec4 color = texture(sampler2D(colorTexture, texSampler), passUVCoord);
    vec4 ssao = texture(sampler2D(ssaoTexture, texSampler), passUVCoord);

    fragmentColor = color;

	if (useLight > 0.5) {
		fragmentColor *= light;
	}

	if (color.a < 0.5) {
		fragmentColor = vec4(0.4,0.4,0.4,1.0);
	}

	if (useSSAO > 0.5) {
		fragmentColor *= (ssao * 0.7 + 0.3);
	}

    //fragmentColor = color;
}