#version 450

layout(location = 0) in vec3 position;

layout(set=0, binding=0) uniform matrixBuffer {
	mat4 viewMatrix;
	mat4 projectionMatrix;
};

layout( push_constant ) uniform constants {
	mat4 modelMatrix;
};

layout(location = 0) out vec4 passPosition;
layout(location = 1) out vec4 midPosition;

layout(location = 2) out vec4 color;

void main() {
	vec3 c = (modelMatrix * vec4(0,0,0,1)).xyz;
	float x = c.x + 2;
	float y = c.y + 2;
	float z = c.z + 2;
	c = vec3(x * 2.3 + y * 5.6 + z * 4.4, x * 3.1 + y * 7.2 + z, x * 4.3 + y + z * 6.9);
	c = sin(c);
	c = c / 2.0 + 1.0;
	c = normalize(c);
	color = vec4(c, 1.0);

    passPosition = viewMatrix * modelMatrix * vec4(position, 1);
    midPosition = viewMatrix * modelMatrix * vec4(0,0,0,1);
    gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);
}